<?php

namespace EventPortal\Domain\Event\Form\ValueObjects;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Support\Arr;

class ValidationData implements Arrayable
{
    /** @var int */
    public $id;

    /** @var string */
    public $rule;

    /** @var string */
    public $message;

    /** @var int */
    public $order;

    /** @var string */
    public $uuid;

    public function __construct(array $validation)
    {
        $this->id = (int) Arr::get($validation, 'id');
        $this->rule = Arr::get($validation, 'rule');
        $this->message = Arr::get($validation, 'message');
        $this->order = (int) Arr::get($validation, 'order');
        $this->uuid = Arr::get($validation, 'uuid');
    }

    public function toArray(): array
    {
        return [
            'id' => $this->id,
            'rule' => $this->rule,
            'message' => $this->message,
            'order' => $this->order,
            'uuid' => $this->uuid,
        ];
    }
}
