<?php

namespace EventPortal\Domain\EventDelegate\Handlers;

use Closure;
use EventPortal\Domain\Delegate\DelegateForm;
use EventPortal\Domain\Form\Payload;

class RegisterDelegate
{
    /**
     * @return mixed
     */
    public function __invoke(Payload $payload, Closure $next)
    {
        $delegate = $payload->getContext('eventDelegate')->delegate;

        $transition = DelegateForm::make($delegate, $payload->getContext('form'))->getDelegateTransition();

        $eventDelegate = $payload->getContext('eventDelegate');

        if ($eventDelegate->canApply($transition) === false) {
            return $next($payload);
        }

        $eventDelegate->apply($transition);
        $eventDelegate->save();

        return $next($payload);
    }
}
